/*
 *	app.h
 *
 *	ʂ
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Tue Jun  4 05:23:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *
 ****************************************************************************/

#define FPS		20			/* t[[g       */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ     */
#define TEXTURE_FNAME	"nuwangi.pgd"		/* eNX`t@C */

#define FIELD_UNIT	64
#define FIELD_X_MIN	 0			/* tB[h`͈ */
#define FIELD_X_MAX	16
#define FIELD_Y_MIN	 0
#define FIELD_Y_MAX	16
#define LIMIT_X_MIN	(FIELD_X_MIN + 4)	/* vC[ړ͈ */
#define LIMIT_X_MAX	(FIELD_X_MAX - 4)
#define LIMIT_Y_MIN	(FIELD_Y_MIN + 4)
#define LIMIT_Y_MAX	(FIELD_Y_MAX - 4)

#define OUTER_COLOR	1	/* vC[ړ͈͊O̐F */
#define INNER_COLOR	2	/* vC[ړ͈͓̐F */

/* LN^` */
typedef struct _CHR {
	short x, y;		/* ]W */
	short w, h;		/* ]TCY     */
} CHR;
#include "nuwangi.h"		/* LN^ԍ */
extern CHR chrs[N_CHRS];	/* ->data.c */

/* LN^S` */
typedef struct _CNT {
	short x, y;		/* LN^SW */
} CNT;
extern CNT cnts[N_CHRS];	/* ->data.c */

/* Aj[V` */
typedef struct _ANM {
	short s;		/* Xs[h(1:<->x:100) */
	short n;		/* LN^ԍz̗vf  */
	short* c;		/* LN^ԍz          */
} ANM;
#define ANM_NUWF_STAND		 0
#define ANM_NUWF_DAMAGE		 1
#define ANM_NUWF_RUN		 2
#define ANM_NUWF_ATTACK1	 3
#define ANM_NUWF_ATTACK2	 4
#define ANM_NUWR_STAND		 5
#define ANM_NUWR_DAMAGE		 6
#define ANM_NUWR_RUN		 7
#define ANM_NUWR_ATTACK1	 8
#define ANM_NUWR_ATTACK2	 9
#define ANM_HAKF_DAMAGE		10
#define ANM_HAKF_RUN		11
#define ANM_HAKR_DAMAGE		12
#define ANM_HAKR_RUN		13
#define ANM_ERUF_DAMAGE		14
#define ANM_ERUF_RUN		15
#define ANM_ERUR_DAMAGE		16
#define ANM_ERUR_RUN		17
#define N_ANMS			18
extern ANM anms[N_ANMS];	/* ->data.c */

/* XvCg` */
typedef struct _SPR {
	short dx, dy;		/* LN^S̃foCXW */
	short i_chr;		/* LN^ԍ               */
	short mirror;		/* 0:ʏ/1:E]            */
} SPR;
#define N_SPRS		32	/* őXvCgv[ */

/* vC[Ǘ */
typedef struct _PLAYER {
	short state;		/* Ԕԍ(PS_*萔)        */
	short count[3];		/* ėpJE^              */
	short x, y;		/* ʒu                      */
	short dir;		/* (0:X+,1:Y+,2:X-,3:Y-) */
} PLAYER;
#define PS_FREE		0	/*                              */
#define PS_STAND	1	/* B    ȌԕύX҂ */
#define PS_DAMAGE	2	/* _[WBȌԕύX҂ */
#define PS_RUN		3	/*                              */
#define PS_ATTACK1	4	/* UP                           */
#define PS_ATTACK2	5	/* UQ                           */
#define PS_COUNT	6

/* GǗ */
typedef struct _ENEMY {
	short state;		/* Ԕԍ(ES_*萔)          */
	short count[3];		/* ėpJE^                */
	short x, y;		/* ʒu                        */
	short dir;		/* (0:X+,1:Y+,2:X-,3:Y-)   */
	short kind;		/* (0:nNI/1:GD) */
	short turn;		/* c]            */
} ENEMY;
#define ES_FREE		0	/*      */
#define ES_DAMAGE	1	/* _[W */
#define ES_RUN		2	/*      */
#define ES_COUNT	3
#define EK_HAK		0	/* nNI */
#define EK_ERU		1	/* GD */
#define EK_COUNT	2
#define N_ENEMIES	16	/* őGo */

/* p[eBNǗ */
typedef struct _PARTICLE {
	short color;		/* F  (10.6rbg),0Ȃ */
	short  x,  y,  z;	/* ʒu(10.6rbg)           */
	short vx, vy, vz;	/* x(10.6rbg)           */
} PARTICLE;
#define N_PARTICLES	256	/* őp[eBNo */

#include "work.h"		/* [NGA` */

/****************************************************************************
 *	main.c
 ****************************************************************************/

void schedule();

/****************************************************************************
 *	demo.c
 ****************************************************************************/

/* f[vB
 * [out]
 *	߂l		0    :AvP[VIB
 *			0ȊO:Q[JnB
 */
int demo();

/****************************************************************************
 *	game.c
 ****************************************************************************/

void game();

/****************************************************************************
 *	draw.c
 ****************************************************************************/

/* _WnfoCXWnւ̕ϊs܂B
 * [in]
 *	lx,ly				ϊ̘_WB
 * [out]
 *	߂l̉ʃn[t[h	XW(foCXWn)B
 *	߂l̏ʃn[t[h	YW(foCXWn)B
 * [note]
 *	* ϊ̃foCXẂAt16rbgłB
 *	  ߂lXWEYWɕɂ́Â悤ɂĂB
 *		x = (short)retval;
 *		y = (short)(retval >> 16);
 *	  ̂悤Ƀrbg}XNƁA16rbgɂȂA
 *	  ԈʂɂȂĂ܂̂ŁAӂB
 *		x = retval       & 0xFFFF; I
 *		y = retval >> 16 & 0xFFFF; I
 */
int log_to_dev(short lx, short ly);

/* tB[h̊iq͗l`܂B
 */
void field_draw();

/* o^ꂽXvCg`܂B
 * [note]
 *	* `ASẴXvCg͓o^܂B
 */
void draw_spr();

/* XvCgo^܂B
 * [in]
 *	dx,dy		LN^S̘_WB
 *	i_chr		LN^ԍB
 *	mirrro		E]tOB(0:]Ȃ/0ȊO:])
 * [note]
 *	* Ww͘_Wnł邱ƂɂӂB
 *	  add_spr()֐ŃfoCXWnɕϊ܂B
 *	* foCXWnYW傫قǁAOɕ`܂B
 */
void add_spr(short lx, short ly, short i_chr, short mirror);

/* Aj[V`܂B
 * [in]
 *	dx,dy		LN^S̘_WB
 *	i_anm		LN^ԍB
 *	c_anm		Aj[VJE^B
 *	mirrro		E]tOB(0:]Ȃ/0ȊO:])
 * [out]
 *	߂l		̃Aj[VJE^B
 * [note]
 *	* Aj[VɑΉLN^XvCgƂēo^邾ŁA
 *	  draw_spr()ĂԂ܂ł͎ۂ̕`͍s܂B
 *	* Aj[VJE^̓[vA0ɖ߂ČJԂ܂B
 *	  ߂l0ǂ𒲂ׂ΁AAj[V̏I𔻒ł܂B
 */
short draw_anm(short lx, short ly, short i_anm, short c_anm, short mirror);

#endif /*__APP_H__*/
