/*
 *	draw.c
 *
 *	ʂ
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Tue Jun  4 21:57:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	log_to_dev
 ****************************************************************************/

int
log_to_dev(short lx, short ly)
{
	short dx, dy;

	lx -= center_lx;
	ly -= center_ly;
	dx = center_dx + lx / 2 + ly / 2; /*  */
	dy = center_dy - lx / 4 + ly / 4; /*  */

	return (dy & 0xFFFF) << 16 | (dx & 0xFFFF);
}

/****************************************************************************
 *	field_draw
 ****************************************************************************/

void
field_draw()
{
	int i, x, y, n1, n2, n3, n4;

	/* XɕsȐ`܂B */
	for(i = LIMIT_Y_MIN; i <= LIMIT_Y_MAX; i++) {
		y = i * FIELD_UNIT;
		n1 = log_to_dev(FIELD_X_MIN * FIELD_UNIT, y);
		n2 = log_to_dev(LIMIT_X_MIN * FIELD_UNIT, y);
		n3 = log_to_dev(LIMIT_X_MAX * FIELD_UNIT, y);
		n4 = log_to_dev(FIELD_X_MAX * FIELD_UNIT, y);
		render_line(&render, (short)n1, (short)(n1 >> 16),
				     (short)n2, (short)(n2 >> 16), OUTER_COLOR);
		render_line(&render, (short)n2, (short)(n2 >> 16),
				     (short)n3, (short)(n3 >> 16), INNER_COLOR);
		render_line(&render, (short)n3, (short)(n3 >> 16),
				     (short)n4, (short)(n4 >> 16), OUTER_COLOR);
	}

	/* YɕsȐ`܂B */
	for(i = LIMIT_X_MIN; i <= LIMIT_X_MAX; i++) {
		x = i * FIELD_UNIT;
		n1 = log_to_dev(x, FIELD_Y_MIN * FIELD_UNIT);
		n2 = log_to_dev(x, LIMIT_Y_MIN * FIELD_UNIT);
		n3 = log_to_dev(x, LIMIT_Y_MAX * FIELD_UNIT);
		n4 = log_to_dev(x, FIELD_Y_MAX * FIELD_UNIT);
		render_line(&render, (short)n1, (short)(n1 >> 16),
				     (short)n2, (short)(n2 >> 16), OUTER_COLOR);
		render_line(&render, (short)n2, (short)(n2 >> 16),
				     (short)n3, (short)(n3 >> 16), INNER_COLOR);
		render_line(&render, (short)n3, (short)(n3 >> 16),
				     (short)n4, (short)(n4 >> 16), OUTER_COLOR);
	}
}

/****************************************************************************
 *	draw_spr
 ****************************************************************************/

static int
compare_spr(const void* spr1, const void* spr2)
{
	return ((SPR*)spr1)->dy - ((SPR*)spr2)->dy;
}

void
draw_spr()
{
	SPR* spr;
	CHR* chr;
	CNT* cnt;
	int i, dx, dy, param;

	/* XvCge[uYW̏(->O)ɕёւ܂B */
	qsort(sprs, n_sprs, sizeof(SPR), compare_spr);

	/* Ȍŕ`܂B */
	for(i = 0, spr = sprs; i < n_sprs; i++, spr++) {
		chr = &chrs[spr->i_chr];
		cnt = &cnts[spr->i_chr];

		/* ]WvZ܂B */
		dx = spr->dx;
		dy = spr->dy;
		if(!spr->mirror) {
			dx -= cnt->x;
			param = DRW_NOMAL;
		} else {
			dx -= chr->w - cnt->x;
			param = DRW_REVX;
		}
		dy -= cnt->y;

		/* IuWFNg`܂B */
		draw_object(&texture, dx, dy, chr->x, chr->y, chr->w, chr->h, param);
	}

	/* XvCge[uɖ߂܂B */
	n_sprs = 0;
}

/****************************************************************************
 *	add_spr
 ****************************************************************************/

void
add_spr(short lx, short ly, short i_chr, short mirror)
{
	int retval;
	SPR* spr;

	/* ɌE܂œo^ĂA܂B */
	if(n_sprs == N_SPRS) return;

	/* o^ʒu擾Ao^𑝂₵܂B */
	spr = &sprs[n_sprs++];

	/* XvCgi[܂B */
	retval = log_to_dev(lx, ly);
	spr->dx = (short)retval;
	spr->dy = (short)(retval >> 16);
	spr->i_chr = i_chr;
	spr->mirror = mirror;
}


/****************************************************************************
 *	draw_chr
 ****************************************************************************/

short
draw_anm(short lx, short ly, short i_anm, short c_anm, short mirror)
{
	ANM* anm;
	int i_chr;

	/* Aj[V`擾܂B */
	ASSERT(0 <= i_anm && i_anm < N_ANMS);
	anm = &anms[i_anm];

	/* LN^ԍ擾܂B */
	ASSERT(c_anm < anm->n * anm->s);
	i_chr = anm->c[c_anm / anm->s];

	/* XvCgo^܂B */
	add_spr(lx, ly, i_chr, mirror);

	/* Aj[VJE^i߂܂B */
	if(++c_anm == anm->n * anm->s) c_anm = 0; /* [v */
	return c_anm;
}
