/*
 *	game.c
 *
 *	ʂ
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Jun  5 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

static void player_init(PLAYER* ply);
static void player_work(PLAYER* ply);
static void enemy_init(ENEMY* enm);
static void enemy_work(ENEMY* enm);
static void particle_gen(short lx, short ly);
static void particle_work();

/****************************************************************************
 *	[Jϐ
 ****************************************************************************/

/* Spe[u */
static char wide_num[] = "OPQRSTUVWX";

/* (0:X+,1:Y+,2:X-,3:Y-)->(x,y) ϊe[u */
static dir_tbl[4][2] = { { 1, 0 }, { 0, 1 }, { -1, 0 }, { 0, -1 } };

/* Goe[uFl->G̎ */
#define EGEN_TBL_SIZE	8
static short egen_tbl[EGEN_TBL_SIZE] = { 0,0,0,0,0,0,0,1 };

/* G]me[uF(,l)->(0:]Ȃ/1:]) */
#define ETURN_TBL_SIZE	8
static short eturn_tbl[EK_COUNT][ETURN_TBL_SIZE] = {
	{ 0,1,1,1,1,1,1,1 },
	{ 0,0,0,0,1,1,1,1 },
};

/* vC[F(Ԕԍ,)->Aj[Vԍ ϊe[u
 * Aj[Vԍ̍ŏʃrbǵAE]tOłB
 */
static short player_anm[PS_COUNT][4] = {
	{ 0, 0, 0, 0 },
	{ ANM_NUWR_STAND   | 0x8000, ANM_NUWF_STAND,   ANM_NUWF_STAND   | 0x8000, ANM_NUWR_STAND   },
	{ ANM_NUWR_DAMAGE  | 0x8000, ANM_NUWF_DAMAGE,  ANM_NUWF_DAMAGE  | 0x8000, ANM_NUWR_DAMAGE  },
	{ ANM_NUWR_RUN     | 0x8000, ANM_NUWF_RUN,     ANM_NUWF_RUN     | 0x8000, ANM_NUWR_RUN     },
	{ ANM_NUWR_ATTACK1 | 0x8000, ANM_NUWF_ATTACK1, ANM_NUWF_ATTACK1 | 0x8000, ANM_NUWR_ATTACK1 },
	{ ANM_NUWR_ATTACK2 | 0x8000, ANM_NUWF_ATTACK2, ANM_NUWF_ATTACK2 | 0x8000, ANM_NUWR_ATTACK2 },
};

/* GF(,Ԕԍ,)->Aj[Vԍ ϊe[u
 * Aj[Vԍ̍ŏʃrbǵAE]tOłB
 */
static short enemy_anm[EK_COUNT][ES_COUNT][4] = {
	{ { 0, 0, 0, 0 },
	  { ANM_HAKR_DAMAGE  | 0x8000, ANM_HAKF_DAMAGE,  ANM_HAKF_DAMAGE  | 0x8000, ANM_HAKR_DAMAGE  },
	  { ANM_HAKR_RUN     | 0x8000, ANM_HAKF_RUN,     ANM_HAKF_RUN     | 0x8000, ANM_HAKR_RUN     } },
	{ { 0, 0, 0, 0 },
	  { ANM_ERUR_DAMAGE  | 0x8000, ANM_ERUF_DAMAGE,  ANM_ERUF_DAMAGE  | 0x8000, ANM_ERUR_DAMAGE  },
	  { ANM_ERUR_RUN     | 0x8000, ANM_ERUF_RUN,     ANM_ERUF_RUN     | 0x8000, ANM_ERUR_RUN     } },
};

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int i, x, y, hit, h_stop, c_egen;
	PLAYER* ply = &player;
	ENEMY* enm;

	/*  */
	score = 0;			/* XRA         */
	player_left = 3;		/* vC[c */
	player_spd = 3;			/* vC[x */
	enemy_spd[EK_HAK] = 4;		/* nNIx   */
	enemy_spd[EK_ERU] = 2;		/* GDx   */
	enemy_turn[EK_HAK] = 2;		/* nNI](ő) */
	enemy_turn[EK_ERU] = 2;		/* GD](ő) */
	enemy_gen_itv = SEC(1.5);	/* GoԊu     */

	/* _WB */
	center_dx = DISP_X * 1 / 2;
	center_dy = DISP_Y * 3 / 5;
	center_lx = LIMIT_X_MAX * FIELD_UNIT;
	center_ly = LIMIT_X_MIN * FIELD_UNIT;

	/* vC[EGEp[eBNB */
	memset(&player, 0, sizeof player);
	memset(enemies, 0, sizeof enemies);
	memset(particles, 0, sizeof particles);
	i_particle_gen = 0;

	/* FIXptHgݒB */
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);

	h_stop = 0;
	c_egen = 0;	/* GoC^[o^C} */

	for(;;) {
		schedule();

		 /* Ot[HITĂAƒ~B */
		if(h_stop) {
			for(i = 0; i < SEC(0.33); i++) yield();
			h_stop = 0;
		}

		/* ʃNAB */
		surface_clear(&surface, 0);

		/* vC[oB */
		if(ply->state == PS_FREE) {
			if(player_left == 0) {
				if(pad & TRG_MASK) break;
			} else {
				player_left--;
				player_init(ply);
			}
		}

		/* GoB */
		if(c_egen < enemy_gen_itv) {
			c_egen++;
		} else {
			/* 󂫃GgT܂B */
			for(i = 0, enm = enemies; i < N_ENEMIES; i++, enm++) {
				if(enm->state == ES_FREE) {
					enemy_init(enm); /* o */
					c_egen = 0;
					break;
				}
			}
			/* 󂫂Ȃc_egen͂̂܂܂ŁAt[ŃgCB */
		}

		/* __WB */
		x = ply->x;
		y = ply->y;
		if(ply->state == PS_RUN) { /* ́A𒍎 */
			x += dir_tbl[ply->dir][0] * FIELD_UNIT;
			y += dir_tbl[ply->dir][1] * FIELD_UNIT;
		}
		center_lx = (x * 1 + center_lx * 7) / 8;
		center_ly = (y * 1 + center_ly * 7) / 8;

		/* vC[ړB */
		if(ply->state != PS_FREE) player_work(ply);

		/* GړB */
		for(i = 0, enm = enemies; i < N_ENEMIES; i++, enm++) {
			if(enm->state != ES_FREE) enemy_work(enm);
		}

		/* B */
		/* vC[->GUB */
		if(ply->state == PS_ATTACK1 || ply->state == PS_ATTACK2) {
			/* Up^[2t[~p^[#(0,1,2,3,4)B
			 * #2`#3̃p^[ɍU肠B
			 */
			if(2 * 2 <= ply->count[0] && ply->count[0] < 2 * (3 + 1)) {
				x = ply->x + dir_tbl[ply->dir][0] * 16/**/;
				y = ply->y + dir_tbl[ply->dir][1] * 24/**/;
				for(i = 0, enm = enemies; i < N_ENEMIES; i++, enm++) {
					if(enm->state == ES_RUN) {
						hit = 0;
						if(ply->dir == 0 || ply->dir == 2) { /*  */
							if(abs(enm->x - x) <= 16/**/ && abs(enm->y - y) <=  8/**/) hit = 1;
						} else {
							if(abs(enm->x - x) <=  8/**/ && abs(enm->y - y) <= 16/**/) hit = 1;
						}
						if(hit) {
							switch(enm->kind) {
							case EK_HAK:
								score += 1;
								if(score > 99999) score = 9999;
								if(score == 10) { /* 10l|AՓxAbv */
									enemy_spd[EK_HAK] = 5;	/* nNIx   */
									enemy_turn[EK_HAK] = 5;	/* nNI](ő) */
									enemy_gen_itv = SEC(1);	/* GoԊu     */
								}
								break;
							case EK_ERU:
								score -= 5;
								if(score < 0) score = 0;
								break;
							}
							enm->state = ES_DAMAGE;
							memset(enm->count, 0, sizeof enm->count);
							h_stop = 1;
						}
					}
				}
			}
		}
		/* G->vC[ڐGB */
		if(ply->state == PS_RUN || ply->state == PS_ATTACK1 || ply->state == PS_ATTACK2) {
			x = ply->x;
			y = ply->y;
			for(i = 0, enm = enemies; i < N_ENEMIES; i++, enm++) {
				if(enm->state == ES_RUN && enm->kind == EK_HAK) {
					if(abs(enm->x - x) <= 8 && abs(enm->y - y) <= 8) {
						ply->state = PS_DAMAGE;
						memset(ply->count, 0, sizeof ply->count);
						hit = 1;
						break; /* c̓G̐ڐG͕sv */
					}
				}
			}
		}

		/* tB[h`B */
		field_draw();

		/* XvCg]B */
		draw_spr();

		/* p[eBNړE`B */
		particle_work();

		/* FIX\B */
		pceFontSetPos(0, 0);
		pceFontPrintf("_ %05d00", score);
		pceFontSetPos(0, DISP_Y - 10);
		if(ply->state == PS_FREE && player_left == 0) {
			pceFontPrintf("편s@A{:߂");
		} else {
			pceFontPrintf("c%.2s", &wide_num[player_left * 2]);
		}
	}
}

/****************************************************************************
 *	player_init
 ****************************************************************************/

static void
player_init(PLAYER* ply)
{
	memset(ply, 0, sizeof(PLAYER)); /* Ô */
	ply->state = PS_STAND;
	memset(ply->count, 0, sizeof ply->count);
	ply->x = (LIMIT_X_MIN + LIMIT_X_MAX) / 2 * FIELD_UNIT;
	ply->y = (LIMIT_Y_MIN + LIMIT_Y_MAX) / 2 * FIELD_UNIT;
	ply->dir = 1;
}

/****************************************************************************
 *	player_work
 ****************************************************************************/

static void
player_work(PLAYER* ply)
{
	int i_anm, mirror, i;

	switch(ply->state) {
	case PS_STAND: /*  */
		i_anm = player_anm[ply->state][ply->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		if((ply->count[1] & 2) == 0) { /* _ŕ\ */
			ply->count[0] = draw_anm(ply->x, ply->y, i_anm, ply->count[0], mirror);
		}

		/* L[͂܂͈莞Ԍo瑖oB */
		ply->count[1]++;
		if(pad & TRG_MASK || ply->count[1] >= SEC(3)) {
			ply->state = PS_RUN;
			memset(ply->count, 0, sizeof ply->count);
		}
		break;

	case PS_DAMAGE:
		i_anm = player_anm[ply->state][ply->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		if((ply->count[1] & 2) == 0) { /* _ŕ\ */
			ply->count[0] = draw_anm(ply->x, ply->y, i_anm, ply->count[0], mirror);
		}

		/* p[eBNB */
		for(i = 0; i < 10; i++) particle_gen(ply->x, ply->y);

		/* 莞Ԍo܂B */
		ply->count[1]++;
		if(ply->count[1] >= SEC(1.5)) {
			ply->state = PS_FREE;
			memset(ply->count, 0, sizeof ply->count);
		}
		break;

	case PS_RUN:
		for(i = 0; i < player_spd; i++) {
			/* ]B */
			switch(ply->dir) {
			case 0: /* X+ */
				if(ply->x % FIELD_UNIT == 0) { /* ]\ */
					if(ply->y < LIMIT_Y_MAX * FIELD_UNIT && (pad & PAD_RI)) {
						ply->dir = 1;
					} else if(ply->y > LIMIT_Y_MIN * FIELD_UNIT && (pad & PAD_LF)) {
						ply->dir = 3;
					} else if(ply->x == LIMIT_X_MAX * FIELD_UNIT) { /* ] */
						if(ply->y < LIMIT_Y_MAX * FIELD_UNIT) {
							ply->dir = 1;
						} else {
							ply->dir = 3;
						}
					}
				}
				break;
			case 1: /* Y+ */
				if(ply->y % FIELD_UNIT == 0) { /* ]\ */
					if(ply->x > LIMIT_X_MIN * FIELD_UNIT && (pad & PAD_RI)) {
						ply->dir = 2;
					} else if(ply->x < LIMIT_X_MAX * FIELD_UNIT && (pad & PAD_LF)) {
						ply->dir = 0;
					} else if(ply->y == LIMIT_Y_MAX * FIELD_UNIT) { /* ] */
						if(ply->x > LIMIT_X_MIN * FIELD_UNIT) {
							ply->dir = 2;
						} else {
							ply->dir = 0;
						}
					}
				}
				break;
			case 2: /* X- */
				if(ply->x % FIELD_UNIT == 0) { /* ]\ */
					if(ply->y > LIMIT_Y_MIN * FIELD_UNIT && (pad & PAD_RI)) {
						ply->dir = 3;
					} else if(ply->y < LIMIT_Y_MAX * FIELD_UNIT && (pad & PAD_LF)) {
						ply->dir = 1;
					} else if(ply->x == LIMIT_X_MIN * FIELD_UNIT) { /* ] */
						if(ply->y > LIMIT_Y_MIN * FIELD_UNIT) {
							ply->dir = 3;
						} else {
							ply->dir = 1;
						}
					}
				}
				break;
			case 3: /* Y- */
				if(ply->y % FIELD_UNIT == 0) { /* ]\ */
					if(ply->x < LIMIT_X_MAX * FIELD_UNIT && (pad & PAD_RI)) {
						ply->dir = 0;
					} else if(ply->x > LIMIT_X_MIN * FIELD_UNIT && (pad & PAD_LF)) {
						ply->dir = 2;
					} else if(ply->y == LIMIT_Y_MIN * FIELD_UNIT) { /* ] */
						if(ply->x < LIMIT_X_MAX * FIELD_UNIT) {
							ply->dir = 0;
						} else {
							ply->dir = 2;
						}
					}
				}
				break;
			}
			/* ړB */
			ply->x += dir_tbl[ply->dir][0];
			ply->y += dir_tbl[ply->dir][1];
		}
		i_anm = player_anm[ply->state][ply->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		ply->count[0] = draw_anm(ply->x, ply->y, i_anm, ply->count[0], mirror);

		/* UB */
		if(pad & TRG_A) {
			ply->state = PS_ATTACK1;
			memset(ply->count, 0, sizeof ply->count);
		} else if(pad & TRG_B) {
			ply->state = PS_ATTACK2;
			memset(ply->count, 0, sizeof ply->count);
		}
		break;

	case PS_ATTACK1: /* UP */
		i_anm = player_anm[ply->state][ply->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		ply->count[0] = draw_anm(ply->x, ply->y, i_anm, ply->count[0], mirror);
		if(ply->count[0] == 0) {
			if(pad & PAD_A) {
				ply->state = PS_ATTACK2;
				memset(ply->count, 0, sizeof ply->count);
			} else {
				ply->state = PS_RUN;
				memset(ply->count, 0, sizeof ply->count);
			}
		}
		break;

	case PS_ATTACK2: /* UQ */
		i_anm = player_anm[ply->state][ply->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		ply->count[0] = draw_anm(ply->x, ply->y, i_anm, ply->count[0], mirror);
		if(ply->count[0] == 0) {
			if(pad & PAD_B) {
				ply->state = PS_ATTACK1;
				memset(ply->count, 0, sizeof ply->count);
			} else {
				ply->state = PS_RUN;
				memset(ply->count, 0, sizeof ply->count);
			}
		}
		break;
	}
}

/****************************************************************************
 *	enemy_init
 ****************************************************************************/

static void
enemy_init(ENEMY* enm)
{
	int n;
	div_t dt;

	/* Ô߁B */
	memset(enm, 0, sizeof(ENEMY));

	/* 낢댈߂邽߂̗𐶐B */
	n = rand();

	/* ށB */
	dt = div(n, EGEN_TBL_SIZE);
	n = dt.quot;
	enm->kind = egen_tbl[dt.rem];

	/* B */
	dt = div(n, 4);
	n = dt.quot;
	enm->dir = dt.rem;

	/* oʒuB */
	switch(enm->dir) {
	case 0: /* X+ */
		dt = div(n, LIMIT_Y_MAX - LIMIT_Y_MIN + 1);
		n = dt.quot;
		enm->x =  FIELD_X_MIN           * FIELD_UNIT;
		enm->y = (LIMIT_Y_MIN + dt.rem) * FIELD_UNIT;
		break;
	case 1: /* Y+ */
		dt = div(n, LIMIT_X_MAX - LIMIT_X_MIN + 1);
		n = dt.quot;
		enm->x = (LIMIT_X_MIN + dt.rem) * FIELD_UNIT;
		enm->y =  FIELD_Y_MIN           * FIELD_UNIT;
		break;
	case 2: /* X- */
		dt = div(n, LIMIT_Y_MAX - LIMIT_Y_MIN + 1);
		n = dt.quot;
		enm->x =  FIELD_X_MAX           * FIELD_UNIT;
		enm->y = (LIMIT_Y_MIN + dt.rem) * FIELD_UNIT;
		break;
	case 3: /* Y- */
		dt = div(n, LIMIT_X_MAX - LIMIT_X_MIN + 1);
		n = dt.quot;
		enm->x = (LIMIT_X_MIN + dt.rem) * FIELD_UNIT;
		enm->y =  FIELD_Y_MAX           * FIELD_UNIT;
		break;
	}

	/* ̑B */
	enm->state = ES_RUN;
	memset(enm->count, 0, sizeof enm->count);
	enm->turn = enemy_turn[enm->kind];
}

/****************************************************************************
 *	enemy_work
 ****************************************************************************/

static void
enemy_work(ENEMY* enm)
{
	int i_anm, mirror, i;
	PLAYER* ply = &player;

	switch(enm->state) {
	case ES_DAMAGE:
		i_anm = enemy_anm[enm->kind][enm->state][enm->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		if((enm->count[1] & 2) == 0) { /* _ŕ\ */
			enm->count[0] = draw_anm(enm->x, enm->y, i_anm, enm->count[0], mirror);
		}

		/* p[eBNB */
		for(i = 0; i < 10; i++) particle_gen(enm->x, enm->y);

		/* 莞Ԍo܂B */
		enm->count[1]++;
		if(enm->count[1] >= SEC(1.5)) {
			enm->state = ES_FREE;
			memset(enm->count, 0, sizeof enm->count);
		}
		break;

	case ES_RUN:
		for(i = 0; i < enemy_spd[enm->kind]; i++) {
			/* ]B */
			if(enm->turn != 0) {
				switch(enm->dir) {
				case 0: /* X+ */
					if(enm->x <= LIMIT_X_MAX * FIELD_UNIT && enm->x % FIELD_UNIT == 0) { /* ]\ */
						if(ply->x <= enm->x) {
							if(enm->y < LIMIT_Y_MAX * FIELD_UNIT && ply->y > enm->y) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 1;
									enm->turn--;
								}
							} else if(enm->y > LIMIT_Y_MIN * FIELD_UNIT && ply->y < enm->y) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 3;
									enm->turn--;
								}
							}
						}
					}
					break;
				case 1: /* Y+ */
					if(enm->y <= LIMIT_Y_MAX * FIELD_UNIT && enm->y % FIELD_UNIT == 0) { /* ]\ */
						if(ply->y <= enm->y) {
							if(enm->x > LIMIT_X_MIN * FIELD_UNIT && ply->x < enm->x) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 2;
									enm->turn--;
								}
							} else if(enm->x < LIMIT_X_MAX * FIELD_UNIT && ply->x > enm->x) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 1;
									enm->turn--;
								}
							}
						}
					}
					break;
				case 2: /* X- */
					if(enm->x >= LIMIT_X_MIN * FIELD_UNIT && enm->x % FIELD_UNIT == 0) { /* ]\ */
						if(ply->x >= enm->x) {
							if(enm->y > LIMIT_Y_MIN * FIELD_UNIT && ply->y < enm->y) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 3;
									enm->turn--;
								}
							} else if(enm->y < LIMIT_Y_MAX * FIELD_UNIT && ply->y > enm->y) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 1;
									enm->turn--;
								}
							}
						}
					}
					break;
				case 3: /* Y- */
					if(enm->y >= LIMIT_Y_MIN * FIELD_UNIT && enm->y % FIELD_UNIT == 0) { /* ]\ */
						if(ply->y >= enm->y) {
							if(enm->x < LIMIT_X_MAX * FIELD_UNIT && ply->x > enm->x) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 0;
									enm->turn--;
								}
							} else if(enm->x > LIMIT_X_MIN * FIELD_UNIT && ply->x < enm->x) {
								if(eturn_tbl[enm->kind][rand() % ETURN_TBL_SIZE]) {
									enm->dir = 2;
									enm->turn--;
								}
							}
						}
					}
					break;
					break;
				}
			}
			/* ړB */
			enm->x += dir_tbl[enm->dir][0];
			enm->y += dir_tbl[enm->dir][1];
			/* tB[hOɏoA܂B */
			if(enm->x < FIELD_X_MIN * FIELD_UNIT || enm->x > FIELD_X_MAX * FIELD_UNIT ||
			   enm->y < FIELD_Y_MIN * FIELD_UNIT || enm->y > FIELD_Y_MAX * FIELD_UNIT) {
				enm->state = ES_FREE;
				return;
			}
		}
		i_anm = enemy_anm[enm->kind][enm->state][enm->dir];
		mirror = i_anm & 0x8000;
		i_anm &= 0x7FFF;
		enm->count[0] = draw_anm(enm->x, enm->y, i_anm, enm->count[0], mirror);
		break;
	}
}

/****************************************************************************
 *	particle_gen
 ****************************************************************************/

static void
particle_gen(short lx, short ly)
{
	/* p[eBNGǵAɈÂi݂܂B
	 * Gg̋/gp̓`FbN܂B
	 * ܂쒆̃p[eBNVp[eBNɕςĂA
	 * قƂǉe͂ȂƎvłB
	 */
	PARTICLE* par = &particles[i_particle_gen];
	i_particle_gen++;
	if(i_particle_gen == N_PARTICLES) i_particle_gen = 0;

	/* Ô߁B */
	memset(par, 0, sizeof(PARTICLE));
	par->color = (4 << 6) - 1;
	par->x = lx;
	par->y = ly;
	par->z = 16 << 6; /* o̍B */
	/* RAND_MAX=0x7FFFł邱ƂɈˑ */
	par->vx = (short)(rand() << 1) >> 12;
	par->vy = (short)(rand() << 1) >> 12;
	par->vz =         rand()       >>  7;
}

/****************************************************************************
 *	particle_gen
 ****************************************************************************/

void
particle_work()
{
	int retval, i, c, x, y, z;
	PARTICLE* par;

	for(i = 0, par = particles; i < N_PARTICLES; i++, par++) {
		/* 󂫃GgȂ΂܂B */
		if(par->color == 0) continue;

		if(par->z == 0) {
			/* nʂɗĂAF܂B
			 * F̐0ɂȂ܂B
			 */
			par->color -= 1 << 2;
			if(par->color < 1 << 6) {
				par->color = 0; /* 󂫂}[N */
				continue;
			}
		} else {
			/* ܂󒆁B */
			par->x += par->vx;
			par->y += par->vy;
			par->z += par->vz;
			par->vx /= 2;
			par->vy /= 2;
			par->vz -= 1 << 4;
			if(par->z <= 0) par->z = 0;
		}

		x = par->x >> 6;
		y = par->y >> 6;
		z = par->z >> 6;
		c = par->color >> 6;
		retval = log_to_dev(par->x, par->y);
		x = (short)retval;
		y = (short)(retval >> 16);
		y -= z;
		render_point(&render, x, y, c);
	}
}
