#include "clip.h"
#include "nuwangi.h"
short chrdef[][4] = {
#define CHRDEF
#include "nuwangi.h"
#undef CHRDEF
};
short center[N_CHRS][2];

unsigned char vbuff[128*88];
TEXTURE tex;

#define CENT_X	(DISP_X / 2)
#define CENT_Y	(DISP_Y / 2)

void
draw_chr(int i_chr, int x, int y, int mirror)
{
	DRAW_OBJECT obj;
	pceLCDSetObject(&obj, &tex, x, y, chrdef[i_chr][0], chrdef[i_chr][1], chrdef[i_chr][2], chrdef[i_chr][3], !mirror ? DRW_NOMAL : DRW_REVX);
	pceLCDDrawObject(obj);
}

int
main()
{
	FILEACC fa;
	int frame, pad, i_chr, x, y, mirror;
	char* p;

	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(50);
	pceLCDDispStart();

	pceFileOpen(&fa, "nuwangi.pgd", FOMD_RD);
	pceFileReadSct(&fa, NULL, 0, 0);
	texture_init(&tex, fa.aptr);
	pceFileClose(&fa);

	if(pceFileOpen(&fa, "nuwangi.cnt", FOMD_RD) == 0) {
		pceFileReadSct(&fa, center, 0, sizeof center);
		pceFileClose(&fa);
	}

	frame = 0;
	i_chr = 0;
	for(;;) {
		yield();
		pad = pcePadGet();
		if((pad & PAD_START) && (pad & PAD_SELECT)) break;
		if(pad & TRG_A) i_chr = (i_chr +           1 ) % N_CHRS;
		if(pad & TRG_B) i_chr = (i_chr + (N_CHRS - 1)) % N_CHRS;
		if((pad & TRG_SELECT) ||
		   (center[i_chr][0] == 0 && center[i_chr][1] == 0)) {
			if(i_chr == 0) {
				center[i_chr][0] = chrdef[i_chr][2] / 2;
				center[i_chr][1] = chrdef[i_chr][3] / 2;
			} else {
				center[i_chr][0] = center[i_chr - 1][0];
				center[i_chr][1] = center[i_chr - 1][1];
			}
		}
		if(pad & TRG_LF) center[i_chr][0]++;
		if(pad & TRG_RI) center[i_chr][0]--;
		if(pad & TRG_UP) center[i_chr][1]++;
		if(pad & TRG_DN) center[i_chr][1]--;

		memset(vbuff, 0, sizeof vbuff);
		mirror = pad & PAD_START;
		if(!mirror) {
			x = CENT_X - center[i_chr][0];
			y = CENT_Y - center[i_chr][1];
		} else {
			x = CENT_X - (chrdef[i_chr][2] - center[i_chr][0]);
			y = CENT_Y - center[i_chr][1];
		}
		draw_chr(i_chr, x, y, mirror);
		if(frame & 1) {
			pceLCDLine(1, 0, CENT_Y, DISP_X, CENT_Y);
			pceLCDLine(1, CENT_X, 0, CENT_X, DISP_Y);
		}
		pceFontSetType(0x82);
		pceFontSetPos(0, 0);
		pceFontPrintf("i = %2d\n"
		              "x = %2d\n"
		              "y = %2d", i_chr, center[i_chr][0], center[i_chr][1]);
		pceLCDTrans();
		frame++;
	}

	pceFileCreate("nuwangi.cnt", sizeof center);
	if(pceFileOpen(&fa, "nuwangi.cnt", FOMD_WR) == 0) {
		pceFileWriteSct(&fa, center, 0, sizeof center);
		pceFileClose(&fa);
	}

	p = vbuff;
	for(i_chr = 0; i_chr < N_CHRS; i_chr++) {
		p += sprintf(p, "{ %2d, %2d }, /* %2d */\n", center[i_chr][0], center[i_chr][1], i_chr);
	}
	pceFileCreate("nuwangi.txt", strlen(vbuff));
	if(pceFileOpen(&fa, "nuwangi.txt", FOMD_WR) == 0) {
		pceFileWriteSct(&fa, vbuff, 0, strlen(vbuff));
		pceFileClose(&fa);
	}

	return 0;
}
